unit ClipInfo;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ExtCtrls, Vcl.Menus,
  ShlObj, Clipbrd, ShellAPI, ActiveX, IniFiles, Vcl.ComCtrls, StrUtils;

function StrCmpLogicalW(psz1, psz2: PWideChar): Integer; stdcall; external 'shlwapi.dll';

const
  FORM_WIDTH_SET       = 860;
  FORM_HEIGHT_SET      = 320;
  FORM_MAX             = 'MAX';
  FORM_MIN             = 'MIN';
  FORM_NORMAL          = 'NORMAL';

  FORM_LEFT_SHIFT      = 9;
  FORM_TOP_SHIFT       = 9;

  MY_DROPEFFECT_COPY   = 'DROPEFFECT_COPY';
  MY_DROPEFFECT_MOVE   = 'DROPEFFECT_MOVE';
  MY_DROPEFFECT_LINK   = 'DROPEFFECT_LINK';
  MY_DROPEFFECT_NONE   = 'DROPEFFECT_NONE';
  MY_DROPEFFECT_SCROLL = 'DROPEFFECT_SCROLL';

  INIFILE_NAME       = 'MeryClipInfo.ini';
  DLL_FOLDER_NAME    = 'Plugins';

  VK_0 = Ord('0');
  VK_1 = Ord('1');
  VK_2 = Ord('2');
  VK_3 = Ord('3');
  VK_4 = Ord('4');
  VK_5 = Ord('5');
  VK_6 = Ord('6');
  VK_7 = Ord('7');
  VK_8 = Ord('8');
  VK_9 = Ord('9');
  VK_A = Ord('A');
  VK_B = Ord('B');
  VK_C = Ord('C');
  VK_D = Ord('D');
  VK_E = Ord('E');
  VK_F = Ord('F');
  VK_G = Ord('G');
  VK_H = Ord('H');
  VK_I = Ord('I');
  VK_J = Ord('J');
  VK_K = Ord('K');
  VK_L = Ord('L');
  VK_M = Ord('M');
  VK_N = Ord('N');
  VK_O = Ord('O');
  VK_P = Ord('P');
  VK_Q = Ord('Q');
  VK_R = Ord('R');
  VK_S = Ord('S');
  VK_T = Ord('T');
  VK_U = Ord('U');
  VK_V = Ord('V');
  VK_W = Ord('W');
  VK_X = Ord('X');
  VK_Y = Ord('Y');
  VK_Z = Ord('Z');
  VK_COMMA      = 188; // #$BC
  VK_PIRIOD     = 190; // #$BE
  VK_SLASH      = 191; // #$BF
  VK_BACKSLASH  = 226; // #$E2
  VK_SEMICOLLON = 187; // #$BB
  VK_COLLON     = 186; // #$BA
  VK_RIGHT_KAGI = 221; // #$DD ]
  VK_AT_MARK    = 192; // #$C0
  VK_LEFT_KAGI  = 219; // #&DB [
  VK_MINUS      = 189; // #$BD
  VK_HATTO      = 222; // #$DE
  VK_YEN        = 220; // #$DC

type
  TMyDropFilesAnsi = record
    uStartFileList: UINT; //t@CXgJnAhX܂ł̃TCY
    uPointX: UINT;        //XW
    uPointY: UINT;        //YW
    uPointEnabled: UINT;  //0:}EXʒugȂ 1:}EXʒug
    uAnsiWide: UINT;      //0:Ansi  1:Wide
    pFileList: PAnsiChar; //t@CXg
  end;

type
  TFormClipInfo = class(TForm)
    Panel10: TPanel;
    RadioGroup1: TRadioGroup;
    RadioGroup2: TRadioGroup;
    RadioGroup3: TRadioGroup;
    ButtonCancel: TButton;
    ButtonCopy: TButton;
    Panel1: TPanel;
    Memo1: TMemo;
    ButtonChangeInfo: TButton;
    Panel2: TPanel;
    Panel3: TPanel;
    Panel11: TPanel;
    Panel12: TPanel;
    Panel13: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    MainMenu1: TMainMenu;
    MenuFile: TMenuItem;
    MenuClose: TMenuItem;
    MenuSetting: TMenuItem;
    MenuCloseESCkey: TMenuItem;
    MenuCloseQkey: TMenuItem;
    MenuCloseXkey: TMenuItem;
    ButtonGetInfo: TButton;
    Separater1: TMenuItem;
    MenuCopyAutoClose: TMenuItem;
    Panel4: TPanel;
    Panel5: TPanel;
    Label4: TLabel;
    Memo4: TMemo;
    RadioGroup4: TRadioGroup;
    RadioGroup5: TRadioGroup;
    Memo5: TMemo;
    Memo2: TMemo;
    Memo3: TMemo;
    Separater2: TMenuItem;
    MenuFolderFileEdit: TMenuItem;
    MenuTypeEdit: TMenuItem;
    MenuOperationEdit: TMenuItem;
    MenuTextEdit: TMenuItem;

    procedure WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo); message WM_GETMINMAXINFO;

    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FormResize(Sender: TObject);
    procedure FormShow(Sender: TObject);

    function  ClipboardFromFiles(var AFlag: Word; var StrList: TStringList): Boolean;
    function  FilesToClipboard(Handle: HWND; const FileNames: Array of string; Flag: Word): Boolean;

    procedure GetInfo(Sender: TObject);

    procedure RadioGroup1Click(Sender: TObject);
    procedure RadioGroup2Click(Sender: TObject);
    procedure RadioGroup3Click(Sender: TObject);
    procedure RadioGroup4Click(Sender: TObject);
    procedure RadioGroup5Click(Sender: TObject);

    procedure ButtonCopyClick(Sender: TObject);
    procedure ButtonChangeInfoClick(Sender: TObject);
    procedure ButtonCancelClick(Sender: TObject);
    procedure ButtonGetInfoClick(Sender: TObject);

    procedure MenuCopyAutoCloseClick(Sender: TObject);
    procedure MenuCloseClick(Sender: TObject);
    procedure MenuCloseESCkeyClick(Sender: TObject);
    procedure MenuCloseQkeyClick(Sender: TObject);
    procedure MenuCloseXkeyClick(Sender: TObject);

    function IsDirectoryEx(FolderFileName: String): Boolean;
    procedure MenuFolderFileEditClick(Sender: TObject);
    procedure MenuTypeEditClick(Sender: TObject);
    procedure MenuOperationEditClick(Sender: TObject);
    procedure MenuTextEditClick(Sender: TObject);

  private
    { Private 錾 }
    FormPosLeft: Integer;
    FormPosTop: Integer;
    FormPosWidth: Integer;
    FormPosHeight: Integer;
    FormPosRight: Integer;
    FormPosButtom: Integer;

    MonitorTop: Integer;
    MonitorLeft: Integer;
    MonitorRight: Integer;
    MonitorButtom: Integer;
    MonitorWidth: Integer;
    MonitorHeight: Integer;

    StrFormState: String;

    IntFormShiftX: Integer;
    IntFormShiftY: Integer;

    StrIniFileName: String;

    BoolCfText: Boolean;

  public
    { Public 錾 }

  end;

var
  FormClipInfo: TFormClipInfo;

implementation

{$R *.dfm}

//explorer
function CompareLogical(List: TStringList; Index1, Index2: Integer): Integer;
begin
  //r
  Result := StrCmpLogicalW(PWideChar(WideString(List[Index1])), PWideChar(WideString(List[Index2])));
end;

//annsFM
function CompareAnnsFM(List: TStringList; Index1, Index2: Integer): Integer;
var
  sStr11: AnsiString;
  sStr12: AnsiString;
begin
  //SJIS
  sStr11 := AnsiString(List[Index1]);
  sStr12 := AnsiString(List[Index2]);
  //r
  Result := AnsiCompareStr(String(AnsiString(sStr11)), String(AnsiString(sStr12)));
end;

//BonsFM
function CompareBonsFM(List: TStringList; Index1, Index2: Integer): Integer;
var
  sStr11: String;
  sStr12: String;
begin
  //Unicode
  sStr11 := List[Index1];
  sStr12 := List[Index2];
  //r
  Result := CompareText(List[Index1], List[Index2]);
end;

procedure TFormClipInfo.WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo);
begin
  //ŏTCY
  with msg.MinMaxInfo^.ptMinTrackSize do
  begin
    x := FORM_WIDTH_SET;
    y := FORM_HEIGHT_SET;
  end;
  //őTCY
  with msg.MinMaxInfo^.ptMaxTrackSize do
  begin
    //
  end;
  //ő剻TCY
  with msg.MinMaxInfo^.ptMaxSize do
  begin
    //
  end;
end;

procedure TFormClipInfo.FormClose(Sender: TObject; var Action: TCloseAction);
begin
;
end;

procedure TFormClipInfo.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
;
end;

procedure TFormClipInfo.FormCreate(Sender: TObject);
var
  IniFile: TIniFile;
begin
  //t@Cݒ
  StrIniFileName := ExtractFilePath(ParamStr(0)) + DLL_FOLDER_NAME + '\' + INIFILE_NAME;

  //
  IntFormShiftX  := 0;
  IntFormShiftY  := 0;

  //
  Memo1.Lines.Clear;
  Memo2.Lines.Clear;
  Memo3.Lines.Clear;
  Memo4.Lines.Clear;
  Memo5.Lines.Clear;

  Memo1.Align    := alClient;
  Memo2.Align    := alClient;
  Memo3.Align    := alClient;
  Memo4.Align    := alClient;
  Panel1.Align   := alClient;
  Panel2.Align   := alClient;
  Panel3.Align   := alClient;
  Panel4.Align   := alClient;

  Memo5.Visible  := FALSE;
  Panel1.Visible := TRUE;
  Panel2.Visible := FALSE;
  Panel3.Visible := FALSE;
  Panel4.Visible := FALSE;

  //m
  IniFile := TIniFile.Create(StrIniFileName);
  //tH[ʒu
  FormPosLeft   := IniFile.ReadInteger('FormClipInfo', 'Left',   0);
  FormPosTop    := IniFile.ReadInteger('FormClipInfo', 'Top',    0);
  FormPosWidth  := IniFile.ReadInteger('FormClipInfo', 'Width',  FORM_WIDTH_SET);
  FormPosHeight := IniFile.ReadInteger('FormClipInfo', 'Height', FORM_HEIGHT_SET);
  StrFormState  := IniFile.ReadString ('FormClipInfo', 'State',  FORM_NORMAL);
  FormPosRight  := FormPosLeft + FormPosWidth;
  FormPosButtom := FormPosTop  + FormPosHeight;
  //Ǎ
  MenuCloseEsckey.Checked    := IniFile.ReadBool   ('ClipInfo',  'CloseESCkey', TRUE);
  MenuCloseQkey.Checked      := IniFile.ReadBool   ('ClipInfo',    'CloseQkey', TRUE);
  MenuCloseXkey.Checked      := IniFile.ReadBool   ('ClipInfo',    'CloseXkey', TRUE);
  MenuCopyAutoClose.Checked  := IniFile.ReadBool   ('Copy',        'AutoClose', FALSE);
  MenuFolderFileEdit.Checked := IniFile.ReadBool   ('FolderFile',   'ReadOnly', FALSE);
  MenuTypeEdit.Checked       := IniFile.ReadBool   ('Type',         'ReadOnly', FALSE);
  MenuOperationEdit.Checked  := IniFile.ReadBool   ('Operation',    'ReadOnly', FALSE);
  MenuTextEdit.Checked       := IniFile.ReadBool   ('Text',         'ReadOnly', FALSE);
  RadioGroup1.ItemIndex      := IniFile.ReadInteger('Sort',            'Index', 0);
  RadioGroup2.ItemIndex      := IniFile.ReadInteger('NameSet',         'Index', 0);
  RadioGroup3.ItemIndex      := IniFile.ReadInteger('DoubleCautation', 'Index', 0);
  RadioGroup4.ItemIndex      := IniFile.ReadInteger('FolderFirst',     'Index', 0);
  RadioGroup5.ItemIndex      := IniFile.ReadInteger('FolderAddYen',    'Index', 0);
  //j
  IniFile.Free;

  //ݒ
  if MenuFolderFileEdit.Checked = TRUE then
  begin
    Memo1.ReadOnly := FALSE;
  end
  else
  begin
    Memo1.ReadOnly := TRUE;
  end;

  //ݒ
  if MenuTypeEdit.Checked = TRUE then
  begin
    Memo2.ReadOnly := FALSE;
  end
  else
  begin
    Memo2.ReadOnly := TRUE;
  end;

  //ݒ
  if MenuOperationEdit.Checked = TRUE then
  begin
    Memo3.ReadOnly := FALSE;
  end
  else
  begin
    Memo3.ReadOnly := TRUE;
  end;

  //ݒ
  if MenuTextEdit.Checked = TRUE then
  begin
    Memo4.ReadOnly := FALSE;
  end
  else
  begin
    Memo4.ReadOnly := TRUE;
  end;
end;

procedure TFormClipInfo.FormDestroy(Sender: TObject);
var
  IniFile: TIniFile;
begin
  //m
  IniFile := TIniFile.Create(StrIniFileName);
  //ۑ
  IniFile.WriteBool   ('ClipInfo',  'CloseESCkey',    MenuCloseEsckey.Checked);
  IniFile.WriteBool   ('ClipInfo',    'CloseQkey',    MenuCloseQkey.Checked);
  IniFile.WriteBool   ('ClipInfo',    'CloseXkey',    MenuCloseXkey.Checked);
  IniFile.WriteBool   ('Copy',        'AutoClose',    MenuCopyAutoClose.Checked);
  IniFile.WriteBool   ('FolderFile',   'ReadOnly',    MenuFolderFileEdit.Checked);
  IniFile.WriteBool   ('Type',         'ReadOnly',    MenuTypeEdit.Checked);
  IniFile.WriteBool   ('Operation',    'ReadOnly',    MenuOperationEdit.Checked);
  IniFile.WriteBool   ('Text',         'ReadOnly',    MenuTextEdit.Checked);
  IniFile.WriteInteger('Sort',            'Index',    RadioGroup1.ItemIndex);
  IniFile.WriteInteger('NameSet',         'Index',    RadioGroup2.ItemIndex);
  IniFile.WriteInteger('DoubleCautation', 'Index',    RadioGroup3.ItemIndex);
  IniFile.WriteInteger('FolderFirst',     'Index',    RadioGroup4.ItemIndex);
  IniFile.WriteInteger('FolderAddYen',    'Index',    RadioGroup5.ItemIndex);
  //j
  IniFile.Free;

  //m
  IniFile := TIniFile.Create (StrIniFileName);
  //ʏ
  if WindowState = wsMaximized then
  begin
    IniFile.WriteString('FormClipInfo', 'State', FORM_MAX);
  end
  else if WindowState = wsMinimized then
  begin
    IniFile.WriteString('FormClipInfo', 'State', FORM_MIN);
  end
  else
  begin
    IniFile.WriteString ('FormClipInfo', 'State',  FORM_NORMAL);
    IniFile.WriteInteger('FormClipInfo', 'Left',   FormClipInfo.Left);
    IniFile.WriteInteger('FormClipInfo', 'Top',    FormClipInfo.Top);
    IniFile.WriteInteger('FormClipInfo', 'Width',  FormClipInfo.Width);
    IniFile.WriteInteger('FormClipInfo', 'Height', FormClipInfo.Height);
  end;
  //j
  IniFile.Free;
end;

procedure TFormClipInfo.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  //ESC
  if      (Shift = []) and (key = VK_ESCAPE) then
  begin
    if (MenuCloseEsckey.Checked = TRUE) then
    begin
      //ݾ
      ButtonCancelClick(Sender);
    end;
  end
  //Q
  else if (Shift = []) and (key = VK_Q) then
  begin
    if (MenuCloseQkey.Checked = TRUE) then
    begin
      //ݾ
      ButtonCancelClick(Sender);
    end;
  end
  //X
  else if (Shift = []) and (key = VK_X) then
  begin
    if (MenuCloseXkey.Checked = TRUE) then
    begin
      //ݾ
      ButtonCancelClick(Sender);
    end;
  end
  //
  else
  begin
    //
  end;
end;

procedure TFormClipInfo.FormResize(Sender: TObject);
begin
;
end;

procedure TFormClipInfo.FormShow(Sender: TObject);
begin
  //FormłȂ̂ŁACreatełȂShowōs
  //FormKeyDowñCxgݒ肷
  FormClipInfo.KeyPreview := TRUE;

  //擾
  GetInfo(Sender);

  //GetSystemMetricst֐gpāCzʑŜ̃TCY擾
  MonitorTop    := GetSystemMetrics(SM_YVIRTUALSCREEN);
  MonitorLeft   := GetSystemMetrics(SM_XVIRTUALSCREEN);
  MonitorWidth  := GetSystemMetrics(SM_CXVIRTUALSCREEN);;
  MonitorHeight := GetSystemMetrics(SM_CYVIRTUALSCREEN);;
  MonitorRight  := MonitorLeft + MonitorWidth;
  MonitorButtom := MonitorTop  + MonitorHeight;

  //\ł ȌԂŕ\
  if ( (MonitorTop  <= FormPosTop  + FORM_TOP_SHIFT ) and (FormPosTop    <= MonitorButtom) ) and
     ( (MonitorTop  <= FormPosButtom                ) and (FormPosButtom <= MonitorButtom) ) and
     ( (MonitorLeft <= FormPosLeft + FORM_LEFT_SHIFT) and (FormPosLeft   <= MonitorRight ) ) and
     ( (MonitorLeft <= FormPosRight                 ) and (FormPosRight  <= MonitorRight ) ) then
  begin
    FormClipInfo.SetBounds(FormPosLeft + IntFormShiftX, FormPosTop + IntFormShiftY, FormPosWidth, FormPosHeight);
  end
  //ʓɕ\łȂ ftHgŕ\
  else
  begin
    FormClipInfo.SetBounds(0, 0 ,FORM_WIDTH_SET, FORM_HEIGHT_SET);
  end;

  //ő
  if StrFormState = FORM_MAX then
  begin
    FormClipInfo.WindowState := wsMaximized;
  end
  //ŏ
  else if StrFormState = FORM_MIN then
  begin
    FormClipInfo.WindowState := wsMinimized;
  end
  //W
  else
  begin
    //
  end;
end;

function TFormClipInfo.ClipboardFromFiles(var AFlag: Word; var StrList: TStringList): Boolean;
var
  Handle1: THandle;
  Handle2: THandle;
  hDrop1: Pointer;
  hDrop2: Pointer;
  iDropSize1: Integer;
  iDropCount1: Integer;
  iRow1: Integer;
  pFilename1: PChar;
  sFilename1: String;
  iEffect1: Integer;
  CF_DROPEFFECT: UINT;
begin
  //
  Result := FALSE;
  AFlag := 0;

  //擾
  if (Clipboard.HasFormat(CF_HDROP)) = FALSE then
  begin
    Exit;
  end;

  //擾
  Handle1 := Clipboard.GetAsHandle(CF_HDROP);
  //擾
  if Handle1 <> 0 then
  begin
    //bN
    hDrop1 := GlobalLock(Handle1);
    try
      //t@C擾
      iDropCount1 := DragQueryFile(Integer(hDrop1), Cardinal(-1), nil, 0);
      //
      StrList.Clear;
      //
      for iRow1 := 0 to iDropCount1-1 do
      begin
        //hbvꂽt@C̃TCY{P擾
        iDropSize1 := DragQueryFile(Integer(hDrop1), iRow1, nil, 0) + 1;
        //mۂď
        pFileName1 := StrAlloc(iDropSize1);
        ZeroMemory(pFileName1, iDropSize1);
        try
          //pFilenameɃt@C擾
          DragQueryFile(Integer(hDrop1), iRow1, pFilename1, iDropSize1);
          //sFilename := pFilename;
          sFilename1 := StrPas(pFileName1);
          StrList.Add(sFilename1);
        finally
          //J
         StrDispose(pFilename1);
         end;
      end;

      //
      CF_DROPEFFECT := RegisterClipboardFormat(CFSTR_PREFERREDDROPEFFECT);
      //擾
      if Clipboard.HasFormat(CF_DROPEFFECT) then
      begin
        //擾
        Handle2 := Clipboard.GetAsHandle(CF_DROPEFFECT);
        //
        if Handle2 <>0 then
        begin
          //bN
          hDrop2 := GlobalLock(Handle2);
          try
            //擾
            iEffect1 := PWord(hDrop2)^;
            //ݒ肵ĕԂ
            AFlag := iEffect1;
            //
            Result := TRUE;
          finally
            //AbN
            GlobalUnlock(Handle2);
          end;
        end;//
      end;//擾
    finally
      //AbN
      GlobalUnlock(Handle1);
    end;
  end;
end;


function TFormClipInfo.FilesToClipboard(Handle: HWND; const FileNames: Array of string; Flag: Word): Boolean;
var
  iGlobal1: HGLOBAL;
  iGlobal2: HGLOBAL;
  iGlobal3: HGLOBAL;
  iRow1: Integer;
  dt21: ^TMyDropFilesAnsi;
  p21: PAnsiChar;
  p22: PWord;
  p23: PAnsiChar;
  iSize1: Integer;
  iSize2: Integer;
  iSize3: Integer;
  iSize4: Integer;
  iSize5: Integer;
  iSize6: Integer;
  iSize7: Integer;
  iSize8: Integer;
  CF_DROPEFFECT: UINT;
begin
  //
  Result := FALSE;

  //t@C̒擾
  iSize4 := 0;
  for iRow1 := 0 to High(FileNames) do
  begin
    //擾
    iSize7 := Length(AnsiString(FileNames[iRow1]));
    //#0
    iSize4 := iSize4 + iSize7 + 1;
  end;
    //#0
    iSize4 := iSize4 + 1;

  //t@CXg̑O܂ł̃TCY擾
  iSize3 := Sizeof(dt21.uStartFileList) + Sizeof(dt21.uPointX) + Sizeof(dt21.uPointY) +
            Sizeof(dt21.uPointEnabled)  + Sizeof(dt21.uAnsiWide);

  //g[^TCY
  iSize1 := iSize3 + iSize4;
  //ݒ肵āAnhԂ
  iGlobal1 := GlobalAlloc(GMEM_SHARE or GMEM_MOVEABLE or GMEM_ZEROINIT, iSize1);

  //Lȃnh擾ł
  if iGlobal1 <> 0 then
  begin
    //nh|C^擾ăbN
    dt21 := GlobalLock(iGlobal1);
    //eݒ
    try
      //ݒ
      dt21.uStartFileList := iSize3;
      dt21.uPointX := 0;
      dt21.uPointY := 0;
      dt21.uPointEnabled := 0;
      dt21.uAnsiWide := 0;
      p21 := PAnsiChar(@dt21.pFileList);
      //|C^t@C̃AhXɐݒ
      dt21.pFileList := p21;
      //t@C]
      for iRow1 := 0 to High(FileNames) do
      begin
        //擾
        iSize2 := Length(AnsiString(FileNames[iRow1]));
        //]
        System.Move(Pointer(AnsiString(FileNames[iRow1]))^, p21^, iSize2);
        //|C^ړ
        Inc(p21, iSize2+1); //t@C̒{#0̒
      end;

      //ݒ肵āAnhԂ
      iGlobal2 := GlobalAlloc(GMEM_SHARE or GMEM_MOVEABLE or GMEM_ZEROINIT, sizeof(UINT));
      //Lȃnh擾ł
      if (iGlobal2 <> 0) then
      begin
        //nh|C^擾ăbN
        p22 := GlobalLock(iGlobal2);
        //eݒ
        try
          p22^ := Flag;
        finally
          //bNKAbNKv
          GlobalUnlock(iGlobal2);
        end;

        //t@C̒擾
        iSize5 := 0;
        for iRow1 := 0 to High(FileNames) do
        begin
          //擾
          iSize8 := Length(AnsiString(FileNames[iRow1]));
          //#13 310
          iSize5 := iSize5 + iSize8 + 2;
        end;
          //#0
          iSize5 := iSize5 + 1;

        //ݒ肵āAnhԂ
        iGlobal3 := GlobalAlloc(GMEM_SHARE or GMEM_MOVEABLE or GMEM_ZEROINIT, iSize5);
        //Lȃnh擾ł
        if (iGlobal3 <> 0) then
        begin

          //nh|C^擾ăbN
          p23 := GlobalLock(iGlobal3);
          //eݒ
          try
            for iRow1 := 0 to High(FileNames) do
            begin
              //擾
              iSize6 := Length(AnsiString(FileNames[iRow1]));
              //] s܂߂
              System.Move(Pointer(AnsiString(FileNames[iRow1]))^, p23^, iSize6);
              //|C^ړ
              Inc(p23, iSize6);
              p23^ := #13;
              //|C^ړ
              Inc(p23, 1);
              p23^ := #10;
              //|C^ړ
              Inc(p23, 1);
            end;
          finally
            //bNKAbNKv
            GlobalUnlock(iGlobal3);
          end;

          //J
          OpenClipboard(FormClipInfo.Handle);
          //Nbv{[hɃf[^Zbg
          CF_DROPEFFECT := RegisterClipboardFormat(CFSTR_PREFERREDDROPEFFECT);
          try
            //Nbv{[hNA
            EmptyClipboard();
            //ݒ
            SetClipboardData(CF_HDROP,      iGlobal1);
            SetClipboardData(CF_DROPEFFECT, iGlobal2);
            SetClipboardData(CF_TEXT,       iGlobal3);
            //
            Result := TRUE;
          finally
            //
            CloseClipboard();
          end;
        end//Lȃnh
        //ȃnh
        else
        begin
          //s
          GlobalFree(iGlobal3);
        end;
      end//Lȃnh

      //ȃnh
      else
      begin
        //s
        GlobalFree(iGlobal2);
      end;
    finally
      //bNKAbNKv
      GlobalUnlock(iGlobal1);
    end;
  end//Lȃnh

  //ȃnh
  else
  begin
    //s
    GlobalFree(iGlobal1);
  end;
end;

procedure TFormClipInfo.GetInfo(Sender: TObject);
var
  iRow1: Integer;
  iFormatID: Integer;
  aFormatName: array [0..MAX_PATH-1] of Char;
  dwEffect:Word;
  StrList1: TStringList;
  StrList2: TStringList;
  StrList3: TStringList;
  StrList4: TStringList;
  StrList5: TStringList;
  sStr1: String;
begin
  //
  BoolCfText := FALSE;

  //
  Memo2.Lines.BeginUpdate;
  //NA
  Memo2.Lines.Clear;
  //擾
  for iRow1 := 0 to ClipBoard.FormatCount-1 do
  begin
    //ID擾
    iFormatID:= ClipBoard.Formats[iRow1];
    //obt@NA
    FillChar(aFormatName, SizeOf(aFormatName), #0);

    //OL
    if GetClipBoardFormatName(iFormatID, aFormatName, SizeOf(aFormatName)) > 0 then
    begin
      Memo2.Lines.Add(IntToHex(ClipBoard.Formats[iRow1], 4) + ' ' + aFormatName);
    end
    //O
    else
    begin
      case ClipBoard.Formats[iRow1] of
        CF_TEXT:
          begin
                            Memo2.Lines.Add(IntToHex(ClipBoard.Formats[iRow1], 4) + ' CF_TEXT');
                            BoolCfText := TRUE;
          end;
        CF_BITMAP:          Memo2.Lines.Add(IntToHex(ClipBoard.Formats[iRow1], 4) + ' CF_BITMAP');
        CF_METAFILEPICT:    Memo2.Lines.Add(IntToHex(ClipBoard.Formats[iRow1], 4) + ' CF_METAFILEPICT');
        CF_SYLK:            Memo2.Lines.Add(IntToHex(ClipBoard.Formats[iRow1], 4) + ' CF_SYLK');
        CF_DIF:             Memo2.Lines.Add(IntToHex(ClipBoard.Formats[iRow1], 4) + ' CF_DIF');
        CF_TIFF:            Memo2.Lines.Add(IntToHex(ClipBoard.Formats[iRow1], 4) + ' CF_TIFF');
        CF_OEMTEXT:         Memo2.Lines.Add(IntToHex(ClipBoard.Formats[iRow1], 4) + ' CF_OEMTEXT');
        CF_DIB:             Memo2.Lines.Add(IntToHex(ClipBoard.Formats[iRow1], 4) + ' CF_DIB');
        CF_PALETTE:         Memo2.Lines.Add(IntToHex(ClipBoard.Formats[iRow1], 4) + ' CF_PALETTE');
        CF_PENDATA:         Memo2.Lines.Add(IntToHex(ClipBoard.Formats[iRow1], 4) + ' CF_PENDATA');
        CF_RIFF:            Memo2.Lines.Add(IntToHex(ClipBoard.Formats[iRow1], 4) + ' CF_RIFF');
        CF_WAVE:            Memo2.Lines.Add(IntToHex(ClipBoard.Formats[iRow1], 4) + ' CF_WAVE');
        CF_UNICODETEXT:     Memo2.Lines.Add(IntToHex(ClipBoard.Formats[iRow1], 4) + ' CF_UNICODETEXT');
        CF_ENHMETAFILE:     Memo2.Lines.Add(IntToHex(ClipBoard.Formats[iRow1], 4) + ' CF_ENHMETAFILE');
        CF_HDROP:           Memo2.Lines.Add(IntToHex(ClipBoard.Formats[iRow1], 4) + ' CF_HDROP');
        CF_LOCALE:          Memo2.Lines.Add(IntToHex(ClipBoard.Formats[iRow1], 4) + ' CF_LOCALE');
        CF_DIBV5:           Memo2.Lines.Add(IntToHex(ClipBoard.Formats[iRow1], 4) + ' CF_DIBV5');
        CF_MAX_XP:          Memo2.Lines.Add(IntToHex(ClipBoard.Formats[iRow1], 4) + ' CF_MAX_XP');
        CF_OWNERDISPLAY:    Memo2.Lines.Add(IntToHex(ClipBoard.Formats[iRow1], 4) + ' CF_OWNERDISPLAY');
        CF_DSPTEXT:         Memo2.Lines.Add(IntToHex(ClipBoard.Formats[iRow1], 4) + ' CF_DSPTEXT');
        CF_DSPBITMAP:       Memo2.Lines.Add(IntToHex(ClipBoard.Formats[iRow1], 4) + ' CF_DSPBITMAP');
        CF_DSPMETAFILEPICT: Memo2.Lines.Add(IntToHex(ClipBoard.Formats[iRow1], 4) + ' CF_DSPMETAFILEPIC');
        CF_DSPENHMETAFILE:  Memo2.Lines.Add(IntToHex(ClipBoard.Formats[iRow1], 4) + ' CF_DSPENHMETAFILE');
        CF_GDIOBJFIRST:     Memo2.Lines.Add(IntToHex(ClipBoard.Formats[iRow1], 4) + ' CF_GDIOBJFIRST');
        CF_GDIOBJLAST:      Memo2.Lines.Add(IntToHex(ClipBoard.Formats[iRow1], 4) + ' CF_GDIOBJLAST');
        CF_PRIVATEFIRST:    Memo2.Lines.Add(IntToHex(ClipBoard.Formats[iRow1], 4) + ' CF_PRIVATEFIRST');
        CF_PRIVATELAST:     Memo2.Lines.Add(IntToHex(ClipBoard.Formats[iRow1], 4) + ' CF_PRIVATELAST');
        else
        begin
                            Memo2.Lines.Add(IntToHex(ClipBoard.Formats[iRow1], 4) + ' UnKown');
        end;
      end;
    end;
  end;
  //ݒ
  if Memo2.Text <> '' then
  begin
    Memo2.SelStart := 0;
  end;
  //
  Memo2.Lines.EndUpdate;

  //m
  StrList1 := TStringList.Create;
  StrList2 := TStringList.Create;
  StrList3 := TStringList.Create;
  StrList4 := TStringList.Create;
  StrList5 := TStringList.Create;

  //擾
  ClipboardFromFiles(dwEffect, StrList1);

  //ݒ
  for iRow1 := 0 to StrList1.Count-1 do
  begin
    //擪ƍŌオ"̏ꍇ
    if (Copy(StrList1.Strings[iRow1],                               1, 1) = '"') and
       (Copy(StrList1.Strings[iRow1], Length(StrList1.Strings[iRow1]), 1) = '"') then
    begin
      StrList2.Add(Copy(StrList1.Strings[iRow1], 2, Length(StrList1.Strings[iRow1])-2));
    end
    //ȊO
    else
    begin
      StrList2.Add(StrList1.Strings[iRow1]);
    end;
  end;

  //tH_擪
  if RadioGroup4.ItemIndex = 1 then
  begin
    //tH_ƃt@C𕪂
    for iRow1 := 0 to StrList2.Count-1 do
    begin
      //tH_
      if IsDirectoryEx(StrList2.Strings[iRow1]) = TRUE then
      begin
        StrList3.Add(StrList2.Strings[iRow1]);
      end
      //t@C
      else
      begin
        StrList4.Add(StrList2.Strings[iRow1]);
      end;
    end;

    //tH_ \[g
    if      RadioGroup1.ItemIndex = 1 then
    begin
      StrList3.CustomSort(CompareLogical);
    end
    else if RadioGroup1.ItemIndex = 2 then
    begin
      StrList3.CustomSort(CompareAnnsFM);
    end
    else if RadioGroup1.ItemIndex = 3 then
    begin
      StrList3.CustomSort(CompareBonsFM);
    end
    else
    begin
      ;
    end;

    //t@C \[g
    if      RadioGroup1.ItemIndex = 1 then
    begin
      StrList4.CustomSort(CompareLogical);
    end
    else if RadioGroup1.ItemIndex = 2 then
    begin
      StrList4.CustomSort(CompareAnnsFM);
    end
    else if RadioGroup1.ItemIndex = 3 then
    begin
      StrList4.CustomSort(CompareBonsFM);
    end
    else
    begin
      ;
    end;

    //tH_ s
    for iRow1 := 0 to StrList3.Count-1 do
    begin
        //t@Ĉ
        if RadioGroup2.ItemIndex = 1 then
        begin
          //ݒ
          sStr1 := ExtractFileName(StrList3.Strings[iRow1]);
          //Ō\ǉ
          if RadioGroup5.ItemIndex = 1 then
          begin
            //ݒ
            sStr1 := sStr1 + '\';
            //_uR[e[VL
            if RadioGroup3.ItemIndex = 0 then
            begin
              StrList5.Add('"' + sStr1 + '"');
            end
            //_uR[e[V
            else
            begin
              StrList5.Add(sStr1);
            end;
          end
          //̂܂
          else
          begin
            //ݒ
            sStr1 := sStr1;
            //_uR[e[VL
            if RadioGroup3.ItemIndex = 0 then
            begin
              StrList5.Add('"' + sStr1 + '"');
            end
            //_uR[e[V
            else
            begin
              StrList5.Add(sStr1);
            end;
          end;
        end

        //tpX
        else
        begin
          //ݒ
          sStr1 := StrList3.Strings[iRow1];
          //Ō\ǉ
          if RadioGroup5.ItemIndex = 1 then
          begin
            //ݒ
            sStr1 := sStr1 + '\';
            //_uR[e[VL
            if RadioGroup3.ItemIndex = 0 then
            begin
              StrList5.Add('"' + sStr1 + '"');
            end
            //_uR[e[V
            else
            begin
              StrList5.Add(sStr1);
            end;
          end
          //̂܂
          else
          begin
            //ݒ
            sStr1 := sStr1;
            //_uR[e[VL
            if RadioGroup3.ItemIndex = 0 then
            begin
              StrList5.Add('"' + sStr1 + '"');
            end
            //_uR[e[V
            else
            begin
              StrList5.Add(sStr1);
            end;
          end;
        end;
    end;

    //t@Cs
    for iRow1 := 0 to StrList4.Count-1 do
    begin
        //t@Ĉ
        if RadioGroup2.ItemIndex = 1 then
        begin
          //ݒ
          sStr1 := ExtractFileName(StrList4.Strings[iRow1]);
          //ݒ
          sStr1 := sStr1;
          //_uR[e[VL
          if RadioGroup3.ItemIndex = 0 then
          begin
            StrList5.Add('"' + sStr1 + '"');
          end
          //_uR[e[V
          else
          begin
            StrList5.Add(sStr1);
          end;
        end
        //tpX
        else
        begin
          //ݒ
          sStr1 := StrList4.Strings[iRow1];
          //ݒ
          sStr1 := sStr1;
          //_uR[e[VL
          if RadioGroup3.ItemIndex = 0 then
          begin
            StrList5.Add('"' + sStr1 + '"');
          end
          //_uR[e[V
          else
          begin
            StrList5.Add(sStr1);
          end;
        end;
    end;
  end

  //ʂȂ
  else
  begin
    //\[g
    if      RadioGroup1.ItemIndex = 1 then
    begin
      StrList2.CustomSort(CompareLogical);
    end
    else if RadioGroup1.ItemIndex = 2 then
    begin
      StrList2.CustomSort(CompareAnnsFM);
    end
    else if RadioGroup1.ItemIndex = 3 then
    begin
      StrList2.CustomSort(CompareBonsFM);
    end
    else
    begin
      ;
    end;

    //s
    for iRow1 := 0 to StrList2.Count-1 do
    begin
      //tH_
      if IsDirectoryEx(StrList2.Strings[iRow1]) = TRUE then
      begin
        //t@Ĉ
        if RadioGroup2.ItemIndex = 1 then
        begin
          //ݒ
          sStr1 := ExtractFileName(StrList2.Strings[iRow1]);
          //Ō\ǉ
          if RadioGroup5.ItemIndex = 1 then
          begin
            //ݒ
            sStr1 := sStr1 + '\';
            //_uR[e[VL
            if RadioGroup3.ItemIndex = 0 then
            begin
              StrList5.Add('"' + sStr1 + '"');
            end
            //_uR[e[V
            else
            begin
              StrList5.Add(sStr1);
            end;
          end
          //̂܂
          else
          begin
            //ݒ
            sStr1 := sStr1;
            //_uR[e[VL
            if RadioGroup3.ItemIndex = 0 then
            begin
              StrList5.Add('"' + sStr1 + '"');
            end
            //_uR[e[V
            else
            begin
              StrList5.Add(sStr1);
            end;
          end;
        end

        //tpX
        else
        begin
          //ݒ
          sStr1 := StrList2.Strings[iRow1];
          //Ō\ǉ
          if RadioGroup5.ItemIndex = 1 then
          begin
            //ݒ
            sStr1 := sStr1 + '\';
            //_uR[e[VL
            if RadioGroup3.ItemIndex = 0 then
            begin
              StrList5.Add('"' + sStr1 + '"');
            end
            //_uR[e[V
            else
            begin
              StrList5.Add(sStr1);
            end;
          end
          //̂܂
          else
          begin
            //ݒ
            sStr1 := sStr1;
            //_uR[e[VL
            if RadioGroup3.ItemIndex = 0 then
            begin
              StrList5.Add('"' + sStr1 + '"');
            end
            //_uR[e[V
            else
            begin
              StrList5.Add(sStr1);
            end;
          end;
        end;
      end
      //t@C
      else
      begin
        //t@Ĉ
        if RadioGroup2.ItemIndex = 1 then
        begin
          //ݒ
          sStr1 := ExtractFileName(StrList2.Strings[iRow1]);
          //ݒ
          sStr1 := sStr1;
          //_uR[e[VL
          if RadioGroup3.ItemIndex = 0 then
          begin
            StrList5.Add('"' + sStr1 + '"');
          end
          //_uR[e[V
          else
          begin
            StrList5.Add(sStr1);
          end;
        end
        //tpX
        else
        begin
          //ݒ
          sStr1 := StrList2.Strings[iRow1];
          //ݒ
          sStr1 := sStr1;
          //_uR[e[VL
          if RadioGroup3.ItemIndex = 0 then
          begin
            StrList5.Add('"' + sStr1 + '"');
          end
          //_uR[e[V
          else
          begin
            StrList5.Add(sStr1);
          end;
        end;
      end;
    end;
  end;

  //ǉ
  Memo1.Lines.BeginUpdate;
  Memo1.Lines.Assign(StrList5);
  if Memo1.Text <> '' then
  begin
    Memo1.SelStart := 0;
  end;
  Memo1.Lines.EndUpdate;

  //j
  StrList1.Free;
  StrList2.Free;
  StrList3.Free;
  StrList4.Free;
  StrList5.Free;

  //Yꍇ́AeLXg擾
  if (Memo1.Lines.Count = 0) and (BoolCfText = TRUE) then
  begin
    //ݒ
    Memo4.Lines.BeginUpdate;
    Memo4.ReadOnly := FALSE;
    Memo4.Lines.Clear;
    Memo4.PasteFromClipboard;
    Memo4.ReadOnly := TRUE;
    if Memo4.Text <> '' then
    begin
      Memo4.SelStart := 0;
    end;
    Memo4.Lines.EndUpdate;

    //ݒ
    if MenuTextEdit.Checked = TRUE then
    begin
      Memo4.ReadOnly := FALSE;
    end
    else
    begin
      Memo4.ReadOnly := TRUE;
    end;
  end;

  //
  Memo3.Lines.BeginUpdate;
  //
  Memo3.Lines.Clear;
  if (dwEffect and DROPEFFECT_COPY) > 0 then
  begin
    Memo3.Lines.Add(MY_DROPEFFECT_COPY);
  end;
  if (dwEffect and DROPEFFECT_MOVE) > 0 then
  begin
    Memo3.Lines.Add(MY_DROPEFFECT_MOVE);
  end;
  if (dwEffect and DROPEFFECT_LINK) > 0 then
  begin
    Memo3.Lines.Add(MY_DROPEFFECT_LINK);
  end;
  if (dwEffect and DROPEFFECT_NONE) > 0 then
  begin
    Memo3.Lines.Add(MY_DROPEFFECT_NONE);
  end;
  if (dwEffect and DROPEFFECT_SCROLL) > 0 then
  begin
    Memo3.Lines.Add(MY_DROPEFFECT_SCROLL);
  end;
  //ݒ
  if Memo3.Text <> '' then
  begin
    Memo3.SelStart := 0;
  end;
  //
  Memo3.Lines.EndUpdate;

  //\ؑ
  Panel1.Visible := TRUE;
  Panel2.Visible := FALSE;
  Panel3.Visible := FALSE;
  Panel4.Visible := FALSE;
end;

procedure TFormClipInfo.MenuCloseClick(Sender: TObject);
begin
  ButtonCancelClick(Sender);
end;

procedure TFormClipInfo.MenuCloseESCkeyClick(Sender: TObject);
begin
  if MenuCloseESCkey.Checked = TRUE then
  begin
    MenuCloseESCkey.Checked := FALSE;
  end
  else
  begin
    MenuCloseESCkey.Checked := TRUE;
  end;
end;

procedure TFormClipInfo.MenuCloseQkeyClick(Sender: TObject);
begin
  if MenuCloseQkey.Checked = TRUE then
  begin
    MenuCloseQkey.Checked := FALSE;
  end
  else
  begin
    MenuCloseQkey.Checked := TRUE;
  end;
end;

procedure TFormClipInfo.MenuCloseXkeyClick(Sender: TObject);
begin
  if MenuCloseXkey.Checked = TRUE then
  begin
    MenuCloseXkey.Checked := FALSE;
  end
  else
  begin
    MenuCloseXkey.Checked := TRUE;
  end;
end;

procedure TFormClipInfo.MenuCopyAutoCloseClick(Sender: TObject);
begin
  if MenuCopyAutoClose.Checked = TRUE then
  begin
    MenuCopyAutoClose.Checked := FALSE;
  end
  else
  begin
    MenuCopyAutoClose.Checked := TRUE;
  end;
end;

procedure TFormClipInfo.MenuFolderFileEditClick(Sender: TObject);
begin
  if MenuFolderFileEdit.Checked = TRUE then
  begin
    MenuFolderFileEdit.Checked := FALSE;
  end
  else
  begin
    MenuFolderFileEdit.Checked := TRUE;
  end;

  //ݒ
  if MenuFolderFileEdit.Checked = TRUE then
  begin
    Memo1.ReadOnly := FALSE;
  end
  else
  begin
    Memo1.ReadOnly := TRUE;
  end;
end;

procedure TFormClipInfo.MenuTypeEditClick(Sender: TObject);
begin
  if MenuTypeEdit.Checked = TRUE then
  begin
    MenuTypeEdit.Checked := FALSE;
  end
  else
  begin
    MenuTypeEdit.Checked := TRUE;
  end;

  //ݒ
  if MenuTypeEdit.Checked = TRUE then
  begin
    Memo2.ReadOnly := FALSE;
  end
  else
  begin
    Memo2.ReadOnly := TRUE;
  end;
end;

procedure TFormClipInfo.MenuOperationEditClick(Sender: TObject);
begin
  if MenuOperationEdit.Checked = TRUE then
  begin
    MenuOperationEdit.Checked := FALSE;
  end
  else
  begin
    MenuOperationEdit.Checked := TRUE;
  end;

  //ݒ
  if MenuOperationEdit.Checked = TRUE then
  begin
    Memo3.ReadOnly := FALSE;
  end
  else
  begin
    Memo3.ReadOnly := TRUE;
  end;
end;

procedure TFormClipInfo.MenuTextEditClick(Sender: TObject);
begin
  if MenuTextEdit.Checked = TRUE then
  begin
    MenuTextEdit.Checked := FALSE;
  end
  else
  begin
    MenuTextEdit.Checked := TRUE;
  end;

  //ݒ
  if MenuTextEdit.Checked = TRUE then
  begin
    Memo4.ReadOnly := FALSE;
  end
  else
  begin
    Memo4.ReadOnly := TRUE;
  end;
end;

procedure TFormClipInfo.RadioGroup1Click(Sender: TObject);
begin
  GetInfo(Sender);
end;

procedure TFormClipInfo.RadioGroup2Click(Sender: TObject);
begin
  GetInfo(Sender);
end;

procedure TFormClipInfo.RadioGroup3Click(Sender: TObject);
begin
  GetInfo(Sender);
end;

procedure TFormClipInfo.RadioGroup4Click(Sender: TObject);
begin
  GetInfo(Sender);
end;

procedure TFormClipInfo.RadioGroup5Click(Sender: TObject);
begin
  GetInfo(Sender);
end;

procedure TFormClipInfo.ButtonCopyClick(Sender: TObject);
begin
  if      Panel1.Visible = TRUE then
  begin
    //ݒ
    Memo5.Lines.Assign(Memo1.Lines);
    Memo5.SelectAll;
    //]
    ClipBoard.AsText := Memo5.SelText;
  end
  else if Panel2.Visible = TRUE then
  begin
    //ݒ
    Memo5.Lines.Assign(Memo2.Lines);
    Memo5.SelectAll;
    //]
    ClipBoard.AsText := Memo5.SelText;
  end
  else if Panel3.Visible = TRUE then
  begin
    //ݒ
    Memo5.Lines.Assign(Memo3.Lines);
    Memo5.SelectAll;
    //]
    ClipBoard.AsText := Memo5.SelText;
  end
  else
  begin
    //ݒ
    Memo5.Lines.Assign(Memo4.Lines);
    Memo5.SelectAll;
    //]
    ClipBoard.AsText := Memo5.SelText;
  end;

  //
  if MenuCopyAutoClose.Checked = TRUE then
  begin
    //I
    Close;
  end;
end;

procedure TFormClipInfo.ButtonChangeInfoClick(Sender: TObject);
begin
  if      Panel1.Visible = TRUE then
  begin
    Panel1.Visible := FALSE;
    Panel2.Visible := TRUE;
    Panel3.Visible := FALSE;
    Panel4.Visible := FALSE;
  end
  else if Panel2.Visible = TRUE then
  begin
    Panel1.Visible := FALSE;
    Panel2.Visible := FALSE;
    Panel3.Visible := TRUE;
    Panel4.Visible := FALSE;
  end
  else if Panel3.Visible = TRUE then
  begin
    Panel1.Visible := FALSE;
    Panel2.Visible := FALSE;
    Panel3.Visible := FALSE;
    Panel4.Visible := TRUE;
  end
  else
  begin
    Panel1.Visible := TRUE;
    Panel2.Visible := FALSE;
    Panel3.Visible := FALSE;
    Panel4.Visible := FALSE;
  end;
end;

procedure TFormClipInfo.ButtonGetInfoClick(Sender: TObject);
begin
  //擾
  GetInfo(Sender);
end;

procedure TFormClipInfo.ButtonCancelClick(Sender: TObject);
begin
  //I
  Close;
end;

function TFormClipInfo.IsDirectoryEx(FolderFileName: String): Boolean;
var
  File1: TSearchRec;
  sStr1: String;
begin
  //
  Result := FALSE;

  //Đݒ
  if Copy(FolderFileName, Length(FolderFileName), 1) = '\' then
  begin
    sStr1 := Copy(FolderFileName, 1, Length(FolderFileName)-1);
  end
  else
  begin
    sStr1 := FolderFileName;
  end;

  //
  if FindFirst(sStr1, faAnyFile, File1) = 0 then
  begin
    //
    try
      //tH_BJgfBNgefBNg͑ΏۊOƂB
      if ((File1.Attr and faDirectory > 0)) and (File1.Name <> '.') and (File1.Name <> '..') then
      begin
        //
        Result := TRUE;
      end;
    finally
      FindClose(File1);
    end;
  end;
end;

end.
