unit Propaty;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ExtCtrls,
  IniFiles;

const
  FORM_WIDTH_SET       = 320;
  FORM_HEIGHT_SET      = 150;
  FORM_MAX             = 'MAX';
  FORM_MIN             = 'MIN';
  FORM_NORMAL          = 'NORMAL';

  FORM_LEFT_SHIFT      = 9;
  FORM_TOP_SHIFT       = 9;

  VK_0 = Ord('0');
  VK_1 = Ord('1');
  VK_2 = Ord('2');
  VK_3 = Ord('3');
  VK_4 = Ord('4');
  VK_5 = Ord('5');
  VK_6 = Ord('6');
  VK_7 = Ord('7');
  VK_8 = Ord('8');
  VK_9 = Ord('9');
  VK_A = Ord('A');
  VK_B = Ord('B');
  VK_C = Ord('C');
  VK_D = Ord('D');
  VK_E = Ord('E');
  VK_F = Ord('F');
  VK_G = Ord('G');
  VK_H = Ord('H');
  VK_I = Ord('I');
  VK_J = Ord('J');
  VK_K = Ord('K');
  VK_L = Ord('L');
  VK_M = Ord('M');
  VK_N = Ord('N');
  VK_O = Ord('O');
  VK_P = Ord('P');
  VK_Q = Ord('Q');
  VK_R = Ord('R');
  VK_S = Ord('S');
  VK_T = Ord('T');
  VK_U = Ord('U');
  VK_V = Ord('V');
  VK_W = Ord('W');
  VK_X = Ord('X');
  VK_Y = Ord('Y');
  VK_Z = Ord('Z');
  VK_COMMA      = 188; // #$BC
  VK_PIRIOD     = 190; // #$BE
  VK_SLASH      = 191; // #$BF
  VK_BACKSLASH  = 226; // #$E2
  VK_SEMICOLLON = 187; // #$BB
  VK_COLLON     = 186; // #$BA
  VK_RIGHT_KAGI = 221; // #$DD ]
  VK_AT_MARK    = 192; // #$C0
  VK_LEFT_KAGI  = 219; // #&DB [
  VK_MINUS      = 189; // #$BD
  VK_HATTO      = 222; // #$DE
  VK_YEN        = 220; // #$DC

type
  TFormPropaty = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    ButtonCancel: TButton;
    ButtonOK: TButton;

    procedure WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo); message WM_GETMINMAXINFO;

    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FormShow(Sender: TObject);
    procedure FormResize(Sender: TObject);

    procedure ButtonOKClick(Sender: TObject);
    procedure ButtonCancelClick(Sender: TObject);

  private
    { Private 錾 }
    FormPosLeft: Integer;
    FormPosTop: Integer;
    FormPosWidth: Integer;
    FormPosHeight: Integer;
    FormPosRight: Integer;
    FormPosButtom: Integer;

    MonitorTop: Integer;
    MonitorLeft: Integer;
    MonitorRight: Integer;
    MonitorButtom: Integer;
    MonitorWidth: Integer;
    MonitorHeight: Integer;

    StrFormState: String;

    IntFormShiftX: Integer;
    IntFormShiftY: Integer;

    StrIniFileName: String;

  public
    { Public 錾 }

  end;

var
  FormPropaty: TFormPropaty;

implementation

{$R *.dfm}

uses ClipInfo;

procedure TFormPropaty.WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo);
begin
  //ŏTCY
  with msg.MinMaxInfo^.ptMinTrackSize do
  begin
    x := FORM_WIDTH_SET;
    y := FORM_HEIGHT_SET;
  end;
  //őTCY
  with msg.MinMaxInfo^.ptMaxTrackSize do
  begin
    //
  end;
  //ő剻TCY
  with msg.MinMaxInfo^.ptMaxSize do
  begin
    //
  end;
end;

procedure TFormPropaty.FormClose(Sender: TObject; var Action: TCloseAction);
var
  IniFile: TiniFile;
begin
  //m
  IniFile := TIniFile.Create (StrIniFileName);
  //ʏ
  if WindowState = wsMaximized then
  begin
    IniFile.WriteString('FormClipInfo', 'State', FORM_MAX);
  end
  else if WindowState = wsMinimized then
  begin
    IniFile.WriteString('FormClipInfo', 'State', FORM_MIN);
  end
  else
  begin
    IniFile.WriteString ('FormPropaty', 'State',  FORM_NORMAL);
    IniFile.WriteInteger('FormPropaty', 'Left',   FormPropaty.Left);
    IniFile.WriteInteger('FormPropaty', 'Top',    FormPropaty.Top);
    IniFile.WriteInteger('FormPropaty', 'Width',  FormPropaty.Width);
    IniFile.WriteInteger('FormPropaty', 'Height', FormPropaty.Height);
  end;
  //j
  IniFile.Free;
end;

procedure TFormPropaty.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
;
end;

procedure TFormPropaty.FormCreate(Sender: TObject);
var
  IniFile: TIniFile;
begin
  //t@Cݒ
  StrIniFileName := ExtractFilePath(ParamStr(0)) + DLL_FOLDER_NAME + '\' + INIFILE_NAME;

  //m
  IniFile := TIniFile.Create(StrIniFileName);
  //tH[ʒu
  FormPosLeft   := IniFile.ReadInteger('FormPropaty', 'Left',   0);
  FormPosTop    := IniFile.ReadInteger('FormPropaty', 'Top',    0);
  FormPosWidth  := IniFile.ReadInteger('FormPropaty', 'Width',  FORM_WIDTH_SET);
  FormPosHeight := IniFile.ReadInteger('FormPropaty', 'Height', FORM_HEIGHT_SET);
  StrFormState  := IniFile.ReadString ('FormPropaty', 'State',  FORM_NORMAL);
  FormPosRight  := FormPosLeft + FormPosWidth;
  FormPosButtom := FormPosTop  + FormPosHeight;
  //j
  IniFile.Free;

  //m
  IniFile := TIniFile.Create(StrIniFileName);
  //j
  IniFile.Free;
end;

procedure TFormPropaty.FormDestroy(Sender: TObject);
begin
;
end;

procedure TFormPropaty.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  //ESC
  if      (Shift = []) and (key = VK_ESCAPE) then
  begin
    //ݾ
    ButtonCancelClick(Sender);
  end
  //
  else
  begin
    //
  end;
;
end;

procedure TFormPropaty.FormResize(Sender: TObject);
begin
;
end;

procedure TFormPropaty.FormShow(Sender: TObject);
begin
  //FormłȂ̂ŁACreatełȂShowōs
  //FormKeyDowñCxgݒ肷
  FormPropaty.KeyPreview := TRUE;

  //GetSystemMetricst֐gpāCzʑŜ̃TCY擾
  MonitorTop    := GetSystemMetrics(SM_YVIRTUALSCREEN);
  MonitorLeft   := GetSystemMetrics(SM_XVIRTUALSCREEN);
  MonitorWidth  := GetSystemMetrics(SM_CXVIRTUALSCREEN);;
  MonitorHeight := GetSystemMetrics(SM_CYVIRTUALSCREEN);;
  MonitorRight  := MonitorLeft + MonitorWidth;
  MonitorButtom := MonitorTop  + MonitorHeight;

  //\ł ȌԂŕ\
  if ( (MonitorTop  <= FormPosTop  + FORM_TOP_SHIFT ) and (FormPosTop    <= MonitorButtom) ) and
     ( (MonitorTop  <= FormPosButtom                ) and (FormPosButtom <= MonitorButtom) ) and
     ( (MonitorLeft <= FormPosLeft + FORM_LEFT_SHIFT) and (FormPosLeft   <= MonitorRight ) ) and
     ( (MonitorLeft <= FormPosRight                 ) and (FormPosRight  <= MonitorRight ) ) then
  begin
    FormPropaty.SetBounds(FormPosLeft + IntFormShiftX, FormPosTop + IntFormShiftY, FormPosWidth, FormPosHeight);
  end
  //ʓɕ\łȂ ftHgŕ\
  else
  begin
    FormPropaty.SetBounds(0, 0 ,FORM_WIDTH_SET, FORM_HEIGHT_SET);
  end;

  //ő
  if StrFormState = FORM_MAX then
  begin
    FormPropaty.WindowState := wsMaximized;
  end
  //ŏ
  else if StrFormState = FORM_MIN then
  begin
    FormPropaty.WindowState := wsMinimized;
  end
  //W
  else
  begin
    //
  end;
end;

procedure TFormPropaty.ButtonOKClick(Sender: TObject);
var
  IniFile: TIniFile;
begin
  //m
  IniFile := TIniFile.Create(StrIniFileName);
  //j
  IniFile.Free;

  //I
  Close;
end;

procedure TFormPropaty.ButtonCancelClick(Sender: TObject);
begin
  //I
  Close;
end;

end.
